# -*- coding: utf-8 -*-
# Filename:  quodlibet.py

import os,commands
from playerBase import Status
from dbusplayer import dbusPlayer
from sys import getfilesystemencoding

class quodlibet(dbusPlayer):
	
	def __init__(self):
		dbusPlayer.__init__(self,"quodlibet","net.sacredchao.QuodLibet","/net/sacredchao/QuodLibet","net.sacredchao.QuodLibet")
		self.iface.connect_to_signal("SongStarted", self.statusPlaying)
		self.iface.connect_to_signal("SongEnded", self.statusStopped)
		self.iface.connect_to_signal("Paused", self.statusPaused)
		self.iface.connect_to_signal("Unpaused", self.statusPlaying)
		self.locale = getfilesystemencoding()
	
	def isActive(self):
		if os.system("ps x | grep quodlibet | grep -v grep > /dev/null") != 0:
			return False
		else:
			return dbusPlayer.isActive(self)
	
	#TRACK SECTION
	def getTitle(self):
		try:
			t=self.iface.CurrentSong()['title']
		except:
			return ''
		else:
			return t
	
	def getArtist(self):
		try:
			a=self.iface.CurrentSong()['artist']
		except:
			return ''
		else:
			return a
	
	def getTimePoint(self):
		return self.iface.GetPosition()
	
	def getMediaFile(self):
		try:
			return unicode(commands.getoutput("quodlibet --print-playing '<~filename>'"), self.locale)
		except:
			return ""
	
	#PLAYER SECTION
	def getStatus(self):
		if(bool(self.iface.IsPlaying())):
			return Status().Playing
		else:
			return Status().Paused
		
	def playFunc(self):
		self.iface.PlayPause()
	
	def pauseFunc(self):
		self.iface.PlayPause()
	
	def stopFunc(self):
		self.iface.Pause()
	
	def prevFunc(self):
		self.iface.Previous()
	
	def nextFunc(self):
		self.iface.Next()
	
	#EVENTS SECTION
	def statusPlaying(self,*args):
		if self.callback != None:
			self.callback(Status().Playing)
	
	def statusPaused(self,*args):
		if self.callback != None:
			self.callback(Status().Paused)
	
	def statusStopped(self,*args):
		if self.callback != None:
			self.callback(Status().Stopped)

