# -*- coding: utf-8 -*-
# Filename: settingWizard.py

from PyQt4.QtCore import *
from PyQt4.QtGui import *

import os, glob

from preferencePath import preferencePath

class settingWizard(QWizard):
	
	def __init__(self, parent = None, *args):
		QWizard.__init__(self, parent)
		self.setWindowIcon(QIcon('./icon/lrcShow-X.png'))
		self.setWindowTitle(_('Setting wizard'))
		self.path = pathWizaedPage()
		self.engine = engineWizardPage()
		self.addPage(self.path)
		self.addPage(self.engine)

class pathWizaedPage(QWizardPage):
	
	def __init__(self, parent = None, *args):
		QWizardPage.__init__(self, parent)
		self.setSubTitle(_('Set paths'))
		mainLayout = QVBoxLayout(None)
		self.lrcPath = preferencePath(self)
		i = os.path.expanduser('~/.lrcShow-X/lrc')
		self.lrcPath.insertPath(i, '0')
		self.lrcPath.savePath.setText(os.path.expanduser('~/.lrcShow-X/lrc'))
		mainLayout.addWidget(self.lrcPath)
		self.setLayout(mainLayout)
		
class engineWizardPage(QWizardPage):
	
	def __init__(self, parent = None, *args):
		QWizardPage.__init__(self, parent)
		self.setSubTitle(_('Set default engine'))
		mainLayout = QVBoxLayout(None)
		mainLayout.setSpacing(100)
		
		self.groupBox = QGroupBox(self)
		layout = QGridLayout(self.groupBox)
		k = -1
		for i in glob.glob('./engines/engine_*.py'):
			i = os.path.basename(i)[7:-3]
			k += 1
			exec 'self.radioButton%d = QRadioButton(\'%s\', self)' %(k, i)
			exec 'layout.addWidget(self.radioButton%d, %d/3, %d %% 3)' %(k, k, k)
			if(i == 'ttPlayer'):
				exec 'self.radioButton%d.setChecked(True)' %(k, )
		
		self.label = QLabel(self)
		self.label.setText(_('This page allows you to set a default internet search engine, which also could be changed from preference of lrcShow-X'))
		self.label.setWordWrap(True)
		
		mainLayout.addWidget(self.groupBox)
		mainLayout.addWidget(self.label)
		self.setLayout(mainLayout)